#include <cln/number.h>
#include <cln/io.h>
#include <cln/float.h>
#include <cln/float_io.h>
#include <cln/real.h>
#include <ctype.h>
#include <stdlib.h>
#include <string.h>

using namespace std;
using namespace cln;

static void
usage (ostream& out)
{
  out << "Usage: pi [digits]" << endl;
}

int
main (int argc, char * argv[])
{
  int digits = 100;
  if (argc > 1) {
    if (argc == 2 && !strcmp(argv[1],"--help")) {
      usage(cout);
      return 0;
    }
    if (argc == 2 && !strcmp(argv[1],"--version")) {
      cout << "pi (cln) " << CL_VERSION_MAJOR << "." << CL_VERSION_MINOR << endl;
      cout << "Written by Bruno Haible." << endl;
      cout << endl;
      cout << "Copyright (C) 1998-2001 Bruno Haible." << endl;
      cout << "This is free software; see the source for copying conditions.  There is NO" << endl;
      cout << "warranty; not even for MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE." << endl;
      cout << endl;
      cout << "Recommended reading: \"Pi\", by Joerg Arndt and Christoph Haenel, Springer 1999" << endl;
      return 0;
    }
    if (argc == 2 && isdigit(argv[1][0])) {
      digits = atoi(argv[1]);
    } else {
      usage(cerr);
      return 1;
    }
  }

  float_format_t prec = float_format(digits);
  cl_F p = pi(prec);
  cout << p << endl;

  return 0;
}
